/* 
   Name: spi.h
   Author: Mathäus Sander & Florian Weinhold

   Desc.: SIP function library for ATmega Prozessors
   License: LGPL
*/

#include<avr/io.h>

#ifndef _SPI_H_
#define _SPI_H_

/*standard SPI*/
#define DDR_SPI0 DDRB
#define DD_MOSI0 DDB5
#define DD_MISO0 DDB6
#define DD_SCK0  DDB7
#define DD_CS0   DDB4

/*UART1 as SPI*/
#define DDR_SPI1 DDRD
#define DD_MOSI1 3
#define DD_MISO1 2
#define XCK1     4

#define UBRR1_SPI1 (F_CPU/(2+BAUD))-1

// initialize 
void SPI1_Init(void);   
void SPI2_Init( void );
// send and recive methode
uint8_t spi1_transmit(uint8_t);
uint8_t spi2_transmit( uint8_t );

#endif
