/* 
   Name: uart.c
   Author: Mathäus Sander & Florian Weinhold

   Desc.: UART output for ATmega
   License: LGPL
*/

#include "uart.h"

static FILE mystdout = FDEV_SETUP_STREAM( uart_putchar, NULL, _FDEV_SETUP_WRITE );

void USART_Init(void) {
	UBRR0 = UBRR_VALUE;

   	UCSR0B = (1<<RXEN0) | (1<<TXEN0);
   	// Frame Format: Asynchron 8N1
   	UCSR0C = (1<<UCSZ01) | (1<<UCSZ00);

    stdout = &mystdout;

#ifdef DEBUG
    printf("UART Initialized\n");
#endif
}

int uart_putchar(char c, FILE *stream)
{
    if (c == '\n')
        uart_putchar('\r', stream);
	
	// Busy Waiting
    while ( !( UCSR0A & (1<<UDRE0)) );

    UDR0 = c;

    return 0;
}
